#ifndef FILTER_H
#define FILTER_H

/**
 * Logiciel Gassst (Global Alignment Short Sequence Search Tool)
 * \file filter.h
 * \brief Module Filter, dfinit le filtre Low Complexity qui dtecte les zones non pertinentes des squences afin de ne pas les indexer
 * \author Dominique Lavenier
 * \author Damien Fleury
 * \version 5.2
 * \date 28/08/2008
 */

/// Fentre du filtre Low complexity
#define WS 12


using namespace std;


/**
 * Mthode permettant d'appliquer le filtre Low Complexity
 * \param data le tableau des donnes de la banque de squences
 * \param id l'index du dbut de la squence
 * \param lenseq la longueur de la squence
 * \return 1 si l'opration s'est droule correctement
 */
int filterLowComplexity (char* data, int lenseq);

#endif

